jQuery(document).ready(function($) {

    $(function() {
        $('.color-field').wpColorPicker();
    });

    /*
     * select2
     */
    $('#week_days_without_delivery').select2();

    /*
     * dates without delivery
     */
    var $selectDateInput = '.dates_without_delivery';
    var $selectDateTextArea = '#dates_without_delivery';
    var $showDates = '.show_dates_without_delivery';
    $($selectDateInput).persianDatepicker({
        calendar:{
            persian: {
                locale: 'en'
            }
        }
    });


    var pd = $($selectDateInput).pDatepicker({
        format: 'YYYY/MM/DD',
        calendar: {
            persian : {
                locale : 'fa'
            }
        },
        initialValue: true,
        initialValueType: 'persian',
        formatter: function (unixDate) {
            var self = this;
            var pdate = new persianDate(unixDate);
            return pdate.toLocale('en').format(self.format);
        },
        onSelect: function (unixDate) {

            var self = this;
            var pdate = new persianDate(unixDate);
            var $selectedDate = pdate.toLocale('en').format(self.format);
            var $allSelectedDates = $($selectDateTextArea).html();

            if(!$allSelectedDates.includes($selectedDate)) {
                if($allSelectedDates.length === 0) {
                    $allSelectedDates = $selectedDate;
                } else {
                    $allSelectedDates = $allSelectedDates + ',' + $selectedDate;
                }
                var $addItem = '<li><span class="remove">x</span><span class="date">' + $selectedDate + '</span></li>';
                $($showDates).html($($showDates).html() + $addItem);
                $($selectDateTextArea).html($allSelectedDates);
            } else {
                alert('تاریخ وارد شده در لیست وجود دارد.');
            }
        }
    });
    var $addedDates = $($selectDateTextArea).html() ? $($selectDateTextArea).html().split(',') : '';
    if($addedDates.length > 0 && $addedDates != '' && $addedDates !== '0') {
        $addedDates.forEach(function (item) {
            var $addItem = '<li><span class="remove">x</span><span class="date">' + item + '</span></li>';
            $($showDates).html($($showDates).html() + $addItem);
        });
    }

    $(document).on('click', $showDates + ' li span.remove', function () {
        var $removeDate = $(this).siblings('.date').html();
        var $allSelectedDates = $($selectDateTextArea).html();
        if($allSelectedDates.includes($removeDate + ',')) {
            $($selectDateTextArea).html($allSelectedDates.replace($removeDate + ',', ''));
        } else if($allSelectedDates.includes(',' + $removeDate)) {
            $($selectDateTextArea).html($allSelectedDates.replace(',' + $removeDate, ''));
        } else {
            $($selectDateTextArea).html($allSelectedDates.replace($removeDate, ''));
        }
        $(this).parent('li').remove();
    });

    $('.delivery-time-date-selection').click(function () {
        $($selectDateInput).focus();
        return false;
    });
    $($selectDateInput).on('change', function () {


    });

    /*
     * select week days hours range
     */
    function hourAlert($type) {
        var $result = '';
        if($type === 'range') {
            $result = 'لطفا یک محدوده صحیح برای ساعت ارسال انتخاب کنید.'
        } else if ($type === 'exist') {
            $result = 'لطفا بازه وارد شده را با توجه به بازه های قبلی انتخاب کنید.'
        }
        alert($result);
    }

    var $popupId = 'new-hours-range-popup';
    var $popupSelector = '#' + $popupId;
    $(document).on('click', '.new-hours-range', function () {

        var $day = $(this).parents('.week-day').attr('data-day');
        $($popupSelector).attr('data-day', $day).addClass('active');
        return false;
    });
    function closePopup() {
        $($popupSelector).attr('data-day', '').removeClass('active');
        $($popupSelector + ' #range-from').attr('value', '0');
        $($popupSelector + ' #range-to').attr('value', '0');
        $($popupSelector + ' #range-volume').attr('value', '0');
        $($popupSelector + ' #range-deactive-hour').attr('value', 'default');
    }
    $(document).click(function(e) {
        if (e.target.id != $popupId && !$('#' + $popupId).find(e.target).length) {
            closePopup();
        }
    });
    $('#staticParent').on('keydown', '#child', function(e){-1!==$.inArray(e.keyCode,[46,8,9,27,13,110])||(/65|67|86|88/.test(e.keyCode)&&(e.ctrlKey===true||e.metaKey===true))&&(!0===e.ctrlKey||!0===e.metaKey)||35<=e.keyCode&&40>=e.keyCode||(e.shiftKey||48>e.keyCode||57<e.keyCode)&&(96>e.keyCode||105<e.keyCode)&&e.preventDefault()});
    $(".new-hours-range-field").keydown(function (e) {
        // Allow: backspace, delete, tab, escape, enter and .
        if ($.inArray(e.keyCode, [46, 8, 9, 27, 13, 110]) !== -1 ||
            // Allow: Ctrl+A, Command+A
            (e.keyCode === 65 && (e.ctrlKey === true || e.metaKey === true)) ||
            // Allow: home, end, left, right, down, up
            (e.keyCode >= 35 && e.keyCode <= 40)) {
            // let it happen, don't do anything
            return;
        }
        // Ensure that it is a number and stop the keypress
        if ((e.shiftKey || (e.keyCode < 48 || e.keyCode > 57)) && (e.keyCode < 96 || e.keyCode > 105)) {
            e.preventDefault();
        }
    });
    $(document).on('click', '.new-hours-add-button', function (event) {
        let $this = $(this);
        let $divRange = '';

        let $dayName = $($popupSelector).attr('data-day');
        let $inputName = 'wcdt_options[days_delivery_hours]['+ $dayName +'][]';
        let $dayDiv = $('.week-day[data-day="' + $dayName + '"] .week-day-hours');

        let $fromHour = parseInt($($popupSelector).find('#range-from').val(), 10);
        let $toHour = parseInt($($popupSelector).find('#range-to').val(), 10);
        let $volume = parseInt($($popupSelector).find('#range-volume').val(), 10);
        let $deactiveHour = parseInt($($popupSelector).find('#range-deactive-hour').val(), 10);

        if( $toHour === '0' || $toHour > 24 ) {
            hourAlert('range');
        } else {

            if ($fromHour < $toHour) {
                if($deactiveHour) {
                    $deactiveHour = '(' + $deactiveHour + ')';
                } else {
                    $deactiveHour = '';
                }
                let $dayContent = $dayDiv.html();
                $divRange = '<div class="hour-range">\n' +
                    '                <span class="remove">x</span><input type="text" class="days_delivery_hours" name="'+ $inputName +'" value="' + $fromHour + '-' + $toHour + '(' + $volume + ')' + $deactiveHour + '"></div>';
                $dayContent += $divRange;
                $dayDiv.html($dayContent);
                closePopup();

            } else {
                hourAlert('range');
            }
        }

        return false;
    });


    $(document).on('click', '.week-day .hour-range .remove', function () {
        $(this).parent('.hour-range').remove();
    });

    // $(document).on('click', 'input[type="submit"]', function () {
    //
    //     /**
    //      * Breaks down given fieldName string to pieces. For ex:
    //      *
    //      * If fieldName is "contact[person][name]" result is ["person", "name"].
    //      * If keepFirstElement is true then result is ["contact", "person", "name"].
    //      * Result may vary if you pass different expression.
    //      *
    //      * @param {string} fieldName that will be splited by expression param.
    //      * @param {regexp} expression used to break down fieldName to pieces.
    //      * @param {boolean} keepFirstElement if false/null first extracted name part will be ommited.
    //      * @return {array} array of strings.
    //      */
    //     var extractFieldNames = function(fieldName, expression, keepFirstElement)
    //     {
    //         expression = expression || /([^\]\[]+)/g;
    //         keepFirstElement = keepFirstElement || false;
    //
    //         var elements = [];
    //         while((searchResult = expression.exec(fieldName)))
    //         {
    //             elements.push(searchResult[0]);
    //         }
    //
    //         if (!keepFirstElement && elements.length > 0) elements.shift();
    //
    //         return elements;
    //     }
    //
    //     /**
    //      * This function modifies target object by setting chain of nested fields.
    //      * Fields will have names as passed in properties array. Value param is assigned to
    //      * field at the end of chain. For ex:
    //      *
    //      * If properties array is ["person", "name"] and value is "abc", target object will be
    //      * modified in this way: target.person.name = "abc";
    //      *
    //      * If field at the end is already defined in target, function won't overwrite it.
    //      *
    //      * @param {object} object that this function will modify.
    //      * @param {array} properties to be createad in target object.
    //      * @param {*} value that will be assigned to the field at the end of chain.
    //      */
    //     var attachProperties = function(target, properties, value)
    //     {
    //         var currentTarget = target;
    //         var propertiesNum = properties.length;
    //         var lastIndex = propertiesNum - 1;
    //
    //         for (var i = 0; i < propertiesNum; ++i)
    //         {
    //             currentProperty = properties[i];
    //
    //             if (currentTarget[currentProperty] === undefined)
    //             {
    //                 currentTarget[currentProperty] = (i === lastIndex) ? value : {};
    //             }
    //
    //             currentTarget = currentTarget[currentProperty];
    //         }
    //     }
    //
    //     /**
    //      * This function converts form fields and values to object stucture that
    //      * then can be easely stringyfied with JSON.stringify() method.
    //      *
    //      * Form fields shoud be named in [square][brackets] convention.
    //      * Nesting of fields will be keeped.
    //      *
    //      * @param {object} jQuery object that represents form element.
    //      * @return {object} plain JS object with properties named after form fields.
    //      */
    //     var convertFormDataToObject = function(form) {
    //
    //         var currentField = null;
    //         var currentProperties = null;
    //
    //         // result of this function
    //         var data = {};
    //
    //         // get array of fields that exist in this form
    //         var fields = form.serializeArray();
    //         console.log(fields);
    //         for (var i = 0; i < fields.length; ++i)
    //         {
    //             currentField = fields[i];
    //             // extract field names
    //             currentProperties = extractFieldNames(currentField.name);
    //             // add new fields to our data object
    //             attachProperties(data, currentProperties, currentField.value);
    //         }
    //
    //         return data;
    //     }
    //
    //
    //     // lets do this...
    //     var form = $('form');
    //     var $settingsData = convertFormDataToObject(form);
    //
    //     $.ajax({
    //         url: dt_ajax.url,
    //         type: 'POST',
    //         data: {
    //             action: 'dt_save_settings',
    //             nonce: dt_ajax.nonce,
    //             settings: $settingsData
    //         }
    //     })
    //         .always(function (result) {
    //             console.log(result);
    //         })
    //
    //     return false;
    // });




});