<?php
if(!function_exists('wcdt_get_option')) {
    function wcdt_get_option($option_name = false, $tab = 'general') {
        $option_key = 'wcdt_options';
        if(!empty($tab !== 'general')) $option_key = 'wcdt_'.$tab.'_options';
        $options = get_option($option_key);

        if(isset($options[$option_name]) and ( $options[$option_name] != '' or $options[$option_name] == '0'))  {
            return $options[$option_name];
        } else {
            return false;
        }
    }
}


if(!function_exists('wcdt_province_for_pw_changes')) {
    function wcdt_province_for_pw_changes($province) {
        return WC_Delivery_Time\Includes\WC_Delivery_Time_Show::province_for_pw_changes($province);
    }
}

if(!function_exists('wcdt_check_location_condition')) {
    function wcdt_check_location_condition() {
        if(isset($_POST['ship_to_different_address']) and !empty($_POST['ship_to_different_address']) and $_POST['ship_to_different_address'] == 1) {
            $state  = ( isset($_POST['shipping_state']) and !empty($_POST['shipping_state']) ) ? $_POST['shipping_state'] : '';
            $city   = ( isset($_POST['shipping_city']) and !empty($_POST['shipping_city']) ) ? $_POST['shipping_city'] : '';
        } else {
            $state  = ( isset($_POST['billing_state']) and !empty($_POST['billing_state'] ) ) ? $_POST['billing_state'] : '';
            $city   =  (isset($_POST['billing_city']) and !empty($_POST['billing_city']) ) ? $_POST['billing_city'] : '';

        }

        if(!isset($state) or empty($state)) {
            if(isset($_POST['s_state']) and !empty($_POST['s_state'])) $state = $_POST['s_state'];
        }

        if(!isset($city) or empty($city)) {
            if(isset($_POST['s_city']) and !empty($_POST['s_city'])) $city = $_POST['s_city'];
        }



        if(!isset($state) or empty($state)) {
            if(isset($_POST['state']) and !empty($_POST['state'])) $state = $_POST['state'];
        }

        if(!isset($city) or empty($city)) {
            if(isset($_POST['city']) and !empty($_POST['city'])) $city = $_POST['city'];
        }

        $matched_location = false;
        $conditions = wcdt_get_option('city_conditions');
        foreach ($conditions as $key => $condition) {
            $state_only = ( isset($condition['province_only']) and !empty($condition['province_only']) and $condition['province_only'] == 'yes' ) ? true : false; ;
            if($state_only) {
                if(wcdt_province_for_pw_changes($condition['province']) == $state) {
                    $matched_location = $key;

                    break;
                }
            } else {
                if(wcdt_province_for_pw_changes($condition['province']) == $state and $condition['city'] == $city) {
                    $matched_location = $key;
                    break;
                }
            }
        }

        if( $matched_location ) return $matched_location;
        return false;
    }
}



if(!function_exists('wcdt_check_fastsending_exist')) {
    function wcdt_check_fastsending_exist($returnCondition = false) {

        $fastsending_status = wcdt_get_option('fastsending_status');
        if(!isset($fastsending_status) or empty($fastsending_status) or $fastsending_status == 'disable') return false;

        $fastsendingHours = wcdt_get_option('fastsending_hours');

        $date = wcdt_date();
        $current_week_day_name = date('l', strtotime( $date ) );
        $current_hour= date('H', strtotime( $date ) );
        if(isset($fastsendingHours[$current_week_day_name]) and !empty($fastsendingHours[$current_week_day_name])) {
            $day_fast_sending = $fastsendingHours[$current_week_day_name];
            $start  = $fastsendingHours[ $current_week_day_name ]['start'];
            $end    = $fastsendingHours[ $current_week_day_name ]['end'];
        }

        if(isset($start, $end) and !empty($start) and !empty($end) and (int)$current_hour < (int)$end and (int)$current_hour >= (int)$start) $fastsending_hour_condition = true;
        else $fastsending_hour_condition = false;
        if(isset($day_fast_sending['all']) and !empty($day_fast_sending['all'])) {
            $fastsending_hour_condition = true;
        }
        $always_show = wcdt_get_option('always_show');
        if( !$always_show ) {
            $offWeekDays = wcdt_get_option('week_days_without_delivery');
            $offDates = explode(',', wcdt_convert_number(wcdt_get_option('dates_without_delivery')));
            $dayDate_i18n = wcdt_convert_number(\WC_Delivery_Time\Includes\WC_Delivery_Time_Show::time_date_i18n('Y/m/d', 0 . ' day'));
            $dayName = strtolower(\WC_Delivery_Time\Includes\WC_Delivery_Time_Show::time_date('l', 0 . ' day'));
            $is_disable_date = (is_array($offDates) and in_array($dayDate_i18n, $offDates)) ? true : ((is_array($offWeekDays) and in_array($dayName, $offWeekDays)) ? true : false);
            if ($is_disable_date) $fastsending_hour_condition = false;
        }

        $fastsending = false;
        if(isset($always_show) and !empty($always_show) and $always_show === 'yes') {
            $default_price = wcdt_get_option('fastsending_default_price');
            if(!isset($default_price) or empty($default_price)) $default_price = 0;
            $matchedPrice = $default_price;
            $fastsending = ($fastsending_hour_condition) ? true : false;


        } else {
            $matched_location = wcdt_check_location_condition();
            if(!$matched_location) return;
            $conditions = wcdt_get_option('city_conditions');
            if(!isset($conditions) or empty($conditions)) return false;


            $fastsending = ($matched_location and isset($conditions[$matched_location]['fast_sending']) and !empty($conditions[$matched_location]['fast_sending']) and $conditions[$matched_location]['fast_sending'] == 'yes' and $fastsending_hour_condition) ? true : '';

            $matchedPrice = $conditions[$matched_location]['fast_sending_price'];

        }
        if($returnCondition) return ['status' => $fastsending, 'matched_price'=> $matchedPrice];
        return $fastsending;

    }
}

if(!function_exists('wcdt_check_location_condition_with_fastsending')) {
    function wcdt_check_location_condition_with_fastsending() {
        if(isset($_POST['ship_to_different_address']) and !empty($_POST['ship_to_different_address']) and $_POST['ship_to_different_address'] == 1) {
            $state  = ( isset($_POST['shipping_state']) and !empty($_POST['shipping_state']) ) ? $_POST['shipping_state'] : '';
            $city   = ( isset($_POST['shipping_city']) and !empty($_POST['shipping_city']) ) ? $_POST['shipping_city'] : '';
        } else {
            $state  = ( isset($_POST['billing_state']) and !empty($_POST['billing_state'] ) ) ? $_POST['billing_state'] : '';
            $city   =  (isset($_POST['billing_city']) and !empty($_POST['billing_city']) ) ? $_POST['billing_city'] : '';

        }

        if(!isset($state) or empty($state)) {
            if(isset($_POST['s_state']) and !empty($_POST['s_state'])) $state = $_POST['s_state'];
        }

        if(!isset($city) or empty($city)) {
            if(isset($_POST['s_city']) and !empty($_POST['s_city'])) $city = $_POST['s_city'];
        }


        if(!isset($state) or empty($state)) {
            if(isset($_POST['state']) and !empty($_POST['state'])) $state = $_POST['state'];
        }

        if(!isset($city) or empty($city)) {
            if(isset($_POST['city']) and !empty($_POST['city'])) $city = $_POST['city'];
        }
        $fast_sending   = wcdt_get_option('fastsending_status');
        $fast_sending   = ( isset($fast_sending) and !empty($fast_sending) and $fast_sending == 'enable') ? true : false;
        $check_fast_sending   = ( $fast_sending and isset($_POST['shipping_method']) and !empty($_POST['shipping_method']) and $_POST['shipping_method'][0] == 'fastsending' ) ? true : false;

        $matched_location = false;
        $conditions = wcdt_get_option('city_conditions');
        if(empty($conditions)) return false;
        foreach ($conditions as $key => $condition) {
            $state_only = ( isset($condition['province_only']) and !empty($condition['province_only']) and $condition['province_only'] == 'yes' ) ? true : false; ;
            if($state_only) {
                if(wcdt_province_for_pw_changes($condition['province']) == $state) {
                    $matched_location = $key;
                    if($check_fast_sending and isset($condition['fast_sending_disable_dt']) and !empty($condition['fast_sending_disable_dt']) and $condition['fast_sending_disable_dt'] == 'yes') $matched_location = false;
                    break;
                }
            } else {
                if(wcdt_province_for_pw_changes($condition['province']) == $state and $condition['city'] == $city) {
                    $matched_location = $key;
                    if($check_fast_sending and isset($condition['fast_sending_disable_dt']) and !empty($condition['fast_sending_disable_dt']) and $condition['fast_sending_disable_dt'] == 'yes') $matched_location = false;
                    break;
                }
            }
        }

        if( $matched_location ) return $matched_location;
        return false;
    }
}

function wcdt_date($date = '', $format = 'Y-m-d H:i:s', $timezone = 'Asia/Tehran', $timestamp = false) {
    date_default_timezone_set("GMT");
    if(empty($timezone)) $timezone = 'Asia/Tehran';
    if(empty($format)) $format = 'Y-m-d H:i:s';

    if(!$timestamp) $original_datetime = !empty($date) ? date($format, strtotime($date)) : date($format);
    else $original_datetime = !empty($date) ? date($format, $date) : date($format);

    $original_timezone = new DateTimeZone('UTC');
    $datetime = new DateTime($original_datetime, $original_timezone);
    if(!$timezone) return $datetime->format($format);

    $target_timezone = new DateTimeZone($timezone);
    $datetime->setTimeZone($target_timezone);
    return $datetime->format($format);
}


add_filter('woocommerce_email_customer_details_fields', function($fields, $sent_to_admin, $order) {
    $order_id = $order->get_id();
    $delivery_time = WC_Delivery_Time\Includes\WC_Delivery_Time_Show::get_delivery_meta_item($order_id);
    if(isset($delivery_time) and !empty($delivery_time)) {
        $fields['delivery_time']['label'] = 'زمان تحویل کالا';
        $fields['delivery_time']['value'] = do_shortcode('[delivery_time order_id="'.$order_id.'"]');
    }
    return $fields;
}, 10, 3);

if( !function_exists('wcdt_get_month_name') ) {
    function wcdt_get_month_name($month) {
        $monthes = [
            1 => 'فروردین',
            2 => 'اردیبهشت',
            3 => 'خرداد',
            4 => 'تیر',
            5 => 'مرداد',
            6 => 'شهریور',
            7 => 'مهر',
            8 => 'آبان',
            9 => 'آذر',
            10 => 'دی',
            11 => 'بهمن',
            12 => 'اسفند',
        ];
        return $monthes[$month];
    }
}

if( !function_exists('wcdt_get_week_name') ) {
    function wcdt_get_week_name($w = false) {
        $week = ['شنبه','یکشنبه','دوشنبه','سه شنبه','چهارشنبه','پنجشنبه','جمعه'];
        if($w === '0' or $w === 0) return $week[0];
        return $w ? $week[$w] : $week;
    }
}


if( !function_exists('wcdt_get_week_name_en') ) {
    function wcdt_get_week_name_en($w = false) {
        $week = ['saturday','sunday','monday','tuesday','wednesday','thursday','friday'];
        if($w === '0' or $w === 0) return $week[0];
        return $w ? $week[$w] : $week;
    }
}

if( !function_exists('wcdt_is_mobile') ) {
    function wcdt_is_mobile()
    {

        $uaFull = strtolower($_SERVER['HTTP_USER_AGENT']);
        $uaStart = substr($uaFull, 0, 4);

        $uaPhone = [
            '(android|bb\d+|meego).+mobile',
            'avantgo',
            'bada\/',
            'blackberry',
            'blazer',
            'compal',
            'elaine',
            'fennec',
            'hiptop',
            'iemobile',
            'ip(hone|od)',
            'iris',
            'kindle',
            'lge ',
            'maemo',
            'midp',
            'mmp',
            'mobile.+firefox',
            'netfront',
            'opera m(ob|in)i',
            'palm( os)?',
            'phone',
            'p(ixi|re)\/',
            'plucker',
            'pocket',
            'psp',
            'series(4|6)0',
            'symbian',
            'treo',
            'up\.(browser|link)',
            'vodafone',
            'wap',
            'windows ce',
            'xda',
            'xiino'
        ];

        $uaMobile = [
            '1207',
            '6310',
            '6590',
            '3gso',
            '4thp',
            '50[1-6]i',
            '770s',
            '802s',
            'a wa',
            'abac|ac(er|oo|s\-)',
            'ai(ko|rn)',
            'al(av|ca|co)',
            'amoi',
            'an(ex|ny|yw)',
            'aptu',
            'ar(ch|go)',
            'as(te|us)',
            'attw',
            'au(di|\-m|r |s )',
            'avan',
            'be(ck|ll|nq)',
            'bi(lb|rd)',
            'bl(ac|az)',
            'br(e|v)w',
            'bumb',
            'bw\-(n|u)',
            'c55\/',
            'capi',
            'ccwa',
            'cdm\-',
            'cell',
            'chtm',
            'cldc',
            'cmd\-',
            'co(mp|nd)',
            'craw',
            'da(it|ll|ng)',
            'dbte',
            'dc\-s',
            'devi',
            'dica',
            'dmob',
            'do(c|p)o',
            'ds(12|\-d)',
            'el(49|ai)',
            'em(l2|ul)',
            'er(ic|k0)',
            'esl8',
            'ez([4-7]0|os|wa|ze)',
            'fetc',
            'fly(\-|_)',
            'g1 u',
            'g560',
            'gene',
            'gf\-5',
            'g\-mo',
            'go(\.w|od)',
            'gr(ad|un)',
            'haie',
            'hcit',
            'hd\-(m|p|t)',
            'hei\-',
            'hi(pt|ta)',
            'hp( i|ip)',
            'hs\-c',
            'ht(c(\-| |_|a|g|p|s|t)|tp)',
            'hu(aw|tc)',
            'i\-(20|go|ma)',
            'i230',
            'iac( |\-|\/)',
            'ibro',
            'idea',
            'ig01',
            'ikom',
            'im1k',
            'inno',
            'ipaq',
            'iris',
            'ja(t|v)a',
            'jbro',
            'jemu',
            'jigs',
            'kddi',
            'keji',
            'kgt( |\/)',
            'klon',
            'kpt ',
            'kwc\-',
            'kyo(c|k)',
            'le(no|xi)',
            'lg( g|\/(k|l|u)|50|54|\-[a-w])',
            'libw',
            'lynx',
            'm1\-w',
            'm3ga',
            'm50\/',
            'ma(te|ui|xo)',
            'mc(01|21|ca)',
            'm\-cr',
            'me(rc|ri)',
            'mi(o8|oa|ts)',
            'mmef',
            'mo(01|02|bi|de|do|t(\-| |o|v)|zz)',
            'mt(50|p1|v )',
            'mwbp',
            'mywa',
            'n10[0-2]',
            'n20[2-3]',
            'n30(0|2)',
            'n50(0|2|5)',
            'n7(0(0|1)|10)',
            'ne((c|m)\-|on|tf|wf|wg|wt)',
            'nok(6|i)',
            'nzph',
            'o2im',
            'op(ti|wv)',
            'oran',
            'owg1',
            'p800',
            'pan(a|d|t)',
            'pdxg',
            'pg(13|\-([1-8]|c))',
            'phil',
            'pire',
            'pl(ay|uc)',
            'pn\-2',
            'po(ck|rt|se)',
            'prox',
            'psio',
            'pt\-g',
            'qa\-a',
            'qc(07|12|21|32|60|\-[2-7]|i\-)',
            'qtek',
            'r380',
            'r600',
            'raks',
            'rim9',
            'ro(ve|zo)',
            's55\/',
            'sa(ge|ma|mm|ms|ny|va)',
            'sc(01|h\-|oo|p\-)',
            'sdk\/',
            'se(c(\-|0|1)|47|mc|nd|ri)',
            'sgh\-',
            'shar',
            'sie(\-|m)',
            'sk\-0',
            'sl(45|id)',
            'sm(al|ar|b3|it|t5)',
            'so(ft|ny)',
            'sp(01|h\-|v\-|v )',
            'sy(01|mb)',
            't2(18|50)',
            't6(00|10|18)',
            'ta(gt|lk)',
            'tcl\-',
            'tdg\-',
            'tel(i|m)',
            'tim\-',
            't\-mo',
            'to(pl|sh)',
            'ts(70|m\-|m3|m5)',
            'tx\-9',
            'up(\.b|g1|si)',
            'utst',
            'v400',
            'v750',
            'veri',
            'vi(rg|te)',
            'vk(40|5[0-3]|\-v)',
            'vm40',
            'voda',
            'vulc',
            'vx(52|53|60|61|70|80|81|83|85|98)',
            'w3c(\-| )',
            'webc',
            'whit',
            'wi(g |nc|nw)',
            'wmlb',
            'wonu',
            'x700',
            'yas\-',
            'your',
            'zeto',
            'zte\-'
        ];

        $isPhone = preg_match('/' . implode($uaPhone, '|') . '/i', $uaFull);
        $isMobile = preg_match('/' . implode($uaMobile, '|') . '/i', $uaStart);

        if ($isPhone || $isMobile) {
            return true;
        } else {
            return false;
        }
    }
}

if( !function_exists('wcdt_get_period_volume') ) {
    function wcdt_get_period_volume($date, $time) {
        $model = \WC_Delivery_Time\Includes\Helper\Model::get_instance();
        return $model->get_period_volume($date, $time);
    }
}

if( !function_exists('wcdt_order_statuses_to_reduce_volume') ) {
    function wcdt_order_statuses_to_reduce_volume($with_prefix = true) {
        $statuses = ['wc-failed', 'wc-refunded', 'wc-cancelled', 'wc-pending'];
        $result = apply_filters('wcdt_order_statuses_to_reduce_volume', $statuses);;
        if(!$with_prefix) {
            array_walk($result, function ( &$item, $key) {
                $item = str_replace('wc-', '', $item);
            });
        }
        return $result;
    }
}

if( !function_exists('wcdt_render_setting_hour_range') ) {
    function wcdt_render_setting_hour_range($hour) {
        preg_match_all('/\(([^\)]*)\)/', $hour, $matches);
        $volume = (isset($matches[1][0]) and !empty($matches[1][0])) ? $matches[1][0] : 0;
        $deactiveHour = (isset($matches[1][1]) and !empty($matches[1][1])) ? $matches[1][1] : 0;

        $hourRange = str_replace((isset($matches[0][0]) and !empty($matches[0][0])) ? $matches[0][0] : '', '', $hour);
        $hourRange = str_replace((isset($matches[0][1]) and !empty($matches[0][1])) ? $matches[0][1] : '', '', $hourRange);
        $hourRange = explode('-', $hourRange);
        $from = $hourRange[0];
        $to = $hourRange[1];
        return ['first'         => $from,
            'second'        => $to,
            'volume'        => $volume,
            'deactiveHour'  => $deactiveHour
        ];
    }
}

if( !function_exists('wcdt_check_hour_to_disable_range') ) {
    function wcdt_check_hour_to_disable_range($dayDate, $hour, $deactiveHour, $dayName) {
        if(isset($hour['deactiveHour']) and !empty($hour['deactiveHour'])) $deactiveHour = $hour['deactiveHour'];

        $from = WC_Delivery_Time\Includes\WC_Delivery_Time_Show::time_date( 'Y/m/d H:i:s', 0 . ' day');
        $to = $dayDate . " {$hour['first']}:00:00";
        $hourLimit = $hour['first'];
        if((float) $deactiveHour < 0) {
            $to = $dayDate . " {$hour['second']}:00:00";
            $hourLimit = $hour['second'];
        }
        $timeDifference = WC_Delivery_Time\Includes\WC_Delivery_Time_Show::different_hours($from, $to);
        $is_disable_range = false;
        if((int)$timeDifference < (int)abs($deactiveHour)) {
            $is_disable_range = true;
        }
        $is_disable_range = apply_filters('delivery_time_disable_range', $is_disable_range, $dayName, $hour);

        return $is_disable_range;
    }
}

if( !function_exists('wcdt_compare_day_hours') ) {
    function wcdt_compare_day_hours($hour, $deactiveHour, $currentHour) {
        if(isset($hour['deactiveHour']) and !empty($hour['deactiveHour'])) $deactiveHour = $hour['deactiveHour'];

        $hourLimit = $hour['first'];
        if((float) $deactiveHour < 0) {
            $hourLimit = $hour['second'];
        }
        if((int)$currentHour < (int)$hourLimit) return true;
        return false;
    }
}

function wcdt_convert_number($string, $input = 'fa') {
    if($input === 'en') {
        return strtr($string, array('0'=>'۰','1'=>'۱','2'=>'۲','3'=>'۳','4'=>'۴','5'=>'۵','6'=>'۶','7'=>'۷','8'=>'۸','9'=>'۹'));
    } else {
        return strtr($string, array('۰'=>'0', '۱'=>'1', '۲'=>'2', '۳'=>'3', '۴'=>'4', '۵'=>'5', '۶'=>'6', '۷'=>'7', '۸'=>'8', '۹'=>'9', '٠'=>'0', '١'=>'1', '٢'=>'2', '٣'=>'3', '٤'=>'4', '٥'=>'5', '٦'=>'6', '٧'=>'7', '٨'=>'8', '٩'=>'9'));
    }
}


function wcdt_remove_class_action ($action,$class,$method) {
    global $wp_filter ;
    if (isset($wp_filter[$action])) {
        $len = strlen($method) ;
        foreach ($wp_filter[$action] as $pri => $actions) {
            foreach ($actions as $name => $def) {
                if (substr($name,-$len) == $method) {
                    if (is_array($def['function'])) {
                        if (get_class($def['function'][0]) == $class) {
                            if (is_object($wp_filter[$action]) && isset($wp_filter[$action]->callbacks)) {
                                unset($wp_filter[$action]->callbacks[$pri][$name]) ;
                            } else {
                                unset($wp_filter[$action][$pri][$name]) ;
                            }
                        }
                    }
                }
            }
        }
    }
}

add_action('admin_init', function () {
    if(class_exists('Persian_Woocommerce_Core'))
        // remove_class_action( 'admin_print_footer_scripts', array( PW()->tools->datepicker, 'inline_js' ) );
        wcdt_remove_class_action( 'admin_print_footer_scripts', 'PW_Tools_DatePicker', 'inline_js' );

});