<?php
namespace WC_Delivery_Time\Includes;

use WC_Delivery_Time\Includes\Compability\Dokan;
use WC_Delivery_Time\Includes\Helper\Model;

class WC_Delivery_Time_Compability {
    protected static $_instance = null;
    private $model;
    private $jDate;
    private $dokan;

    public static function get_instance() {
        if ( is_null( self::$_instance ) ) {
            self::$_instance = new self();
        }

        return self::$_instance;
    }

    public function __construct() {
        $this->model = Model::get_instance();
        $this->jDate = \WC_Delivery_Time_jDate::get_instance();

        if(class_exists('WoocommerceIR_SMS_Helper')) {
            $is_compatible_with_persian_woo_sms = wcdt_get_option('pwsms_compatible');
            if (isset($is_compatible_with_persian_woo_sms) and !empty($is_compatible_with_persian_woo_sms) and $is_compatible_with_persian_woo_sms == 'enable')
                add_filter('pwoosms_order_sms_body_after_replace', [$this, 'pwoosms_order_sms_body_after_replace'], 10, 4);
        }
        if(class_exists('WeDevs_Dokan')) {
        	require_once 'compability/dokan.class.php';
            $this->dokan = Dokan::get_instance();
            add_action('dokan_order_detail_after_order_items', [$this->dokan, 'dokan_order_detail_after_order_items'], 10, 1);
            add_action('dokan_new_product_form', [$this->dokan, 'dokan_new_product_form'], 10, 2);
            add_action('dokan_product_after_variation_pricing', [$this->dokan, 'dokan_product_after_variation_pricing'], 10, 3);
            add_action( 'dokan_process_product_meta', [$this->dokan, 'dokan_process_product_meta'], 10, 1 );
            add_action( 'woocommerce_save_product_variation', [$this->dokan, 'dokan_save_product_variation'], 99, 2);

        }
    }


    public function pwoosms_order_sms_body_after_replace($content, $order_id, $order, $product_ids) {
        $wcdt_result = '';
        $delivery_info = WC_Delivery_Time_Show::get_delivery_meta_item( $order_id );
        if(isset($delivery_info) && !empty($delivery_info)){
            $delivery_date = $delivery_info[0]['delivery_date'];
            $delivery_hour = $delivery_info[0]['delivery_time'];
            $wcdt_result = 'تاریخ: '. wcdt_convert_number(WC_Delivery_Time_Show::get_date_i18n($delivery_date)) .'- ساعت: '. $delivery_hour;
        }

        $content = str_replace('{delivery_time}', $wcdt_result, $content);
        return $content;
    }


}