<?php
namespace WC_Delivery_Time\Includes\Compability;

use WC_Delivery_Time\Includes\Helper\Model;

class Dokan
{
	public static $instance = NULL;

	public static function get_instance()
	{
		NULL === self::$instance and self::$instance = new self;
		return self::$instance;
	}

	public function __construct()
    {
    	$this->model = Model::get_instance();
    	$this->jDate = \WC_Delivery_Time_jDate::get_instance();
    }


    public function dokan_order_detail_after_order_items($order) {
        $order_id = $order->get_id();
        $delivery_info = $this->model->get_delivery_meta_item($order_id);
        if(isset($delivery_info) && !empty($delivery_info)):
            ?>

            <div class="dokan-left dokan-order-delivery-time">
                <div class="dokan-panel dokan-panel-default">
                    <div class="dokan-panel-heading"><strong>زمان تحویل کالا</strong></div>
                    <div class="dokan-panel-body">
                        <div class="show-delivery-time">
                            <?php
                            $delivery_date = $delivery_info[0]['delivery_date'];
                            $delivery_hour = $delivery_info[0]['delivery_time'];

                            ?>
                            <div class="item">
                                <span class="title">تاریخ:</span>
                                <span class="desc"><?php echo $this->jDate->jdate('Y/m/d', $delivery_date); ?></span>
                            </div>
                            <div class="item">
                                <span class="title">زمان:</span>
                                <span class="desc"><?php echo $delivery_hour; ?></span>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        <?php
        endif;
    }

    public function dokan_new_product_form($post = false, $post_id = false) {
		if(!isset($post_id) or empty($post_id)) return;
		$readyDays = get_post_meta($post_id, '_delivery_ready_in_days', true);
	    ?>
		<div class="show_if_simple" style="margin-top: 20px">
			<div class="dokan-form-group">
				<label for="_delivery_ready_in_days">زمان آماده شدن محصول</label>
				<input type="number" name="_delivery_ready_in_days" class="dokan-form-control" id="_delivery_ready_in_days" value="<?php echo (isset($readyDays) and !empty($readyDays)) ? $readyDays : ''; ?>" placeholder="تعداد روز آماده شدن محصول">
				<p>تعداد روزهایی که طول میکشد تا محصول آماده ارسال شود. این مقدار در زمان ارسال کالا در نظر گرفته میشود.</p>
			</div>
		</div>
		<?php
    }


    public function dokan_process_product_meta($product_id) {
        $fields_to_save = ['_delivery_ready_in_days'];

        foreach($fields_to_save as $key => $field) {
            $field_value = (isset($_POST[$field]) and !empty($_POST[$field])) ? $_POST[$field] : '';
            if ( $field_value ) {
                update_post_meta( $product_id, $field, $field_value );
            } else {
                delete_post_meta( $product_id, $field );
            }
        }

    }

    public function dokan_product_after_variation_pricing($loop, $variation_data, $variation) {
		$default = get_post_meta( $variation->ID, '_delivery_ready_in_days', true );
		?>
	    <div>
			<div class="dokan-form-group form-row-full">
				<label for="_delivery_ready_in_days[<?php echo $loop; ?>]">زمان آماده شدن محصول</label>
				<input type="number" class="dokan-form-control" name="_delivery_ready_in_days[<?php echo $loop; ?>]" value="<?php echo (isset($default) and !empty($default)) ? $default : ''; ?>" placeholder="تعداد روز آماده شدن محصول">
				<p>تعداد روزهایی که طول میکشد تا محصول آماده ارسال شود. این مقدار در زمان ارسال کالا در نظر گرفته میشود.</p>

			</div>
	    </div>
		<?php
    }


    public function dokan_save_product_variation($variation_id, $loop) {
        $parent_id = $_POST['product_id'];
        if(!isset($parent_id) or empty($parent_id)) {
            $parent_id = $_POST['dokan_product_id'];
        }
        if(!isset($parent_id) or empty($parent_id)) return;


        $fields_to_save = ['_delivery_ready_in_days'];
        foreach($fields_to_save as $key => $field) {
            $field_value = (isset($_POST[$field][$loop]) and !empty($_POST[$field][$loop])) ? $_POST[$field][$loop] : '';
            if(!empty($field_value)) {
                update_post_meta( $variation_id, $field, $field_value );
            } else {
                delete_post_meta( $variation_id, $field );
            }
        }

    }
}