<?php
namespace WC_Delivery_Time\Includes\Helper;

class Model
{
    public static $instance = NULL;
    private $wcdt_table;
    private $wcdt_table_volume;


    public static function get_instance()
    {
        NULL === self::$instance and self::$instance = new self;
        return self::$instance;
    }

    public function __construct() {
        global $wpdb;
        $this->wcdt_table = $wpdb->prefix.'woocommerce_delivery_time';
        $this->wcdt_table_volume = $wpdb->prefix.'woocommerce_delivery_time_volume';
    }


    public function getDeliveryDataByDate($from, $to) {
        global $wpdb;
        return $wpdb->get_results("SELECT * FROM {$this->wcdt_table} WHERE `delivery_date` >= '{$from}' AND `delivery_date` <= '{$to}' ", 'ARRAY_A');
    }

    public function get_delivery_meta_item($order_id) {
        global $wpdb;
        return $wpdb->get_results("SELECT * FROM {$this->wcdt_table} WHERE `delivery_orders` LIKE '%{$order_id}%' ", 'ARRAY_A');
    }

    public function update_delivery_meta($date, $time, $order_id, $count = 1) {
        global $wpdb;
        $deliveryInfo = $wpdb->get_results("SELECT * FROM {$this->wcdt_table} WHERE `delivery_date` = {$date} AND `delivery_time` = '{$time}' ", 'ARRAY_A');
        $this->maybe_remove_old_delivery_time($order_id);

        if(isset($deliveryInfo) and !empty($deliveryInfo)) {
            $currentCount = $deliveryInfo[0]['delivery_count'];
            $deliveryOrders = unserialize($deliveryInfo[0]['delivery_orders']);
            $pos = array_search($order_id, $deliveryOrders);
            unset($deliveryOrders[$pos]);
            $deliveryOrders[] = $order_id;
            $data = array('delivery_orders' => serialize($deliveryOrders), 'delivery_count' => $currentCount + $count);
            $where = array('delivery_date' => $date, 'delivery_time' => $time);
            $wpdb->update( $this->wcdt_table, $data, $where );
        } else {
            $data = array('delivery_date' => $date, 'delivery_time' => $time, 'delivery_orders' => serialize(array($order_id)), 'delivery_count' => $count);
            $format = array('%d', '%s', '%s','%d');
            $wpdb->insert($this->wcdt_table,$data,$format);
        }
    }

    public function maybe_remove_old_delivery_time($order_id) {
        global $wpdb;
        $deliveryInfo = $wpdb->get_results("SELECT * FROM {$this->wcdt_table} WHERE `delivery_orders` LIKE '%{$order_id}%' ", 'ARRAY_A');
        foreach ($deliveryInfo as $key => $value) {
            $currentCount = $value['delivery_count'];

            $orders = unserialize($value);
            $pos = array_search($order_id, $orders);
            unset($orders[$pos]);
            $data = array('delivery_orders' => serialize($orders), 'delivery_count' => $currentCount - 1);
            $where = array('delivery_date' => $value['delivery_date'], 'delivery_time' => $value['delivery_time']);
            $wpdb->update( $this->wcdt_table, $data, $where );
        }
    }

    public function update_delivery_volume($date, $time, $order_id) {
        $updated_volume = get_post_meta($order_id, '_updated_delivery_volume', true);
        if(isset($updated_volume) and !empty($updated_volume)) return;
        global $wpdb;
        $deliveryInfo = $wpdb->get_row("SELECT * FROM {$this->wcdt_table_volume} WHERE `delivery_date` = {$date} AND `delivery_time` = '{$time}' ", 'ARRAY_A');

        if(isset($deliveryInfo) and !empty($deliveryInfo)) {
            $currentCount = $deliveryInfo['delivery_count'];
            $data = array('delivery_count' => $currentCount + 1);
            $where = array('delivery_date' => $date, 'delivery_time' => $time);
            $wpdb->update( $this->wcdt_table_volume, $data, $where );
        } else {
            $data = array('delivery_date' => $date, 'delivery_time' => $time, 'delivery_count' => 1);
            $format = array('%s', '%s', '%d');
            $wpdb->insert($this->wcdt_table_volume,$data,$format);
        }

        update_post_meta($order_id, '_updated_delivery_volume', [$date, $time]);
        delete_post_meta($order_id, '_reduced_delivery_volume');
    }


    public function reduce_delivery_volume($date, $time, $order_id) {
        $reduced_volume = get_post_meta($order_id, '_reduced_delivery_volume', true);
        if(isset($reduced_volume) and !empty($reduced_volume)) return;
        global $wpdb;
        $deliveryInfo = $wpdb->get_row("SELECT * FROM {$this->wcdt_table_volume} WHERE `delivery_date` = {$date} AND `delivery_time` = '{$time}' ", 'ARRAY_A');

        if(isset($deliveryInfo) and !empty($deliveryInfo)) {
            $currentCount = $deliveryInfo['delivery_count'];
            $data = array('delivery_count' => $currentCount - 1 );
            $where = array('delivery_date' => $date, 'delivery_time' => $time);
            $wpdb->update( $this->wcdt_table_volume, $data, $where );
        }
        wp_clear_scheduled_hook( 'check_delivery_count', array( $order_id ) );
        update_post_meta($order_id, '_reduced_delivery_volume', [$date, $time]);
        delete_post_meta($order_id, '_updated_delivery_volume');
    }


    public function get_period_volume($date, $time) {
        global $wpdb;
        $table = $wpdb->prefix.'woocommerce_delivery_time_volume';
        $volume = $wpdb->get_var("SELECT delivery_count FROM {$table} WHERE `delivery_date` = {$date} AND `delivery_time` = '{$time}'");
        if(isset($volume) and !empty($volume)) return $volume;
        return 0;
    }
}