<?php
namespace WC_Delivery_Time\Includes\Helper;

class Upgrade
{
    public static $instance = NULL;
    private $wcdt_table;


    public static function get_instance()
    {
        NULL === self::$instance and self::$instance = new self;
        return self::$instance;
    }

    public function __construct() {
        global $wpdb;
        $this->wcdt_table_volume = $wpdb->prefix.'woocommerce_delivery_time_volumen';
    }

    public function check_version() {
        if(version_compare(WCDT_VERSION, '2.6.0', '>')) {
            $this->create_volume_table();
        }
    }

    public function create_volume_table() {

        global $wpdb;
        $table_name = $wpdb->prefix . 'woocommerce_delivery_time_volume';

        if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
            $sql = "CREATE TABLE " . $table_name . " (
                `id` mediumint(9) NOT NULL AUTO_INCREMENT,
                `delivery_date` text NOT NULL,
                `delivery_time` text NOT NULL,
                `delivery_count` int(3) NOT NULL,
                UNIQUE KEY id (id)
                );";
            require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
            dbDelta($sql);

        }
    }

}