<?php
$classic_days_bg = wcdt_get_option('classic_days_bg', 'design');
$classic_days_color = wcdt_get_option('classic_days_color', 'design');
$classic_days_date_color = wcdt_get_option('classic_days_date_color', 'design');
$classic_days_size = wcdt_get_option('classic_days_size', 'design');
$classic_days_weight = wcdt_get_option('classic_days_weight', 'design');
$classic_days_date_weight = wcdt_get_option('classic_days_date_weight', 'design');
$classic_days_date_size = wcdt_get_option('classic_days_date_size', 'design');
$classic_hours_size = wcdt_get_option('classic_hours_size', 'design');
$classic_hours_weight = wcdt_get_option('classic_hours_weight', 'design');
$classic_hours_color = wcdt_get_option('classic_hours_color', 'design');
$classic_hours_bg = wcdt_get_option('classic_hours_bg', 'design');
$classic_hours_bg_selected = wcdt_get_option('classic_hours_bg_selected', 'design');
$classic_hours_color_selected = wcdt_get_option('classic_hours_color_selected', 'design');
?>

<style>
    #delivery_date_field table.delivery_dates td input[type="radio"] + label {
        <?php if(isset($classic_hours_size) and !empty($classic_hours_size)): ?>
            font-size: <?php echo $classic_hours_size; ?>px !important;
        <?php endif; ?>
        <?php if(isset($classic_hours_weight) and !empty($classic_hours_weight)): ?>
            font-weight: <?php echo $classic_hours_weight; ?> !important;
        <?php endif; ?>
        <?php if(isset($classic_hours_color) and !empty($classic_hours_color)): ?>
            color: <?php echo $classic_hours_color; ?> !important;
        <?php endif; ?>
        <?php if(isset($classic_hours_bg) and !empty($classic_hours_bg)): ?>
            background: <?php echo $classic_hours_bg; ?> !important;
        <?php endif; ?>
    }
    #delivery_date_field table.delivery_dates td input[type="radio"]:checked + label {

    <?php if(isset($classic_hours_color_selected) and !empty($classic_hours_color_selected)): ?>
        color: <?php echo $classic_hours_color_selected; ?> !important;
    <?php endif; ?>
    <?php if(isset($classic_hours_bg_selected) and !empty($classic_hours_bg_selected)): ?>
        background: <?php echo $classic_hours_bg_selected; ?> !important;
    <?php endif; ?>
    }
</style>

<?php do_action('delivery_time_before_list'); ?>
<div id="delivery_date_field" style="display: block;">
    <?php $wcdt_title = wcdt_get_option('delivery_time_title', 'text'); ?>
    <?php if(isset($wcdt_title) and !empty($wcdt_title)): ?>
        <h3><?php echo $wcdt_title; ?></h3>
    <?php else: ?>
        <h3><?php _e('Select delivery date and time: ', 'wcdt'); ?></h3>
    <?php endif;?>
    <table class="shop_table shop_table_responsive delivery_dates">
        <tbody>
        <?php
        $skipped_days_count = 0;
        for($i = 0 + $dayStartFrom; $i <= $daysToShowNumber + $dayStartFrom - 1; $i++) {
            $dayName = strtolower(self::time_date( 'l', $i . ' day'));
            $dayDate_i18n = wcdt_convert_number(self::time_date_i18n( 'Y/m/d', $i . ' day'));
            $dayDate = wcdt_convert_number(self::time_date( 'Y/m/d', $i . ' day'));
            $dayTimestamp = self::date_timestamp( $dayDate );
            $is_disable = (is_array($offDates) and in_array($dayDate_i18n, $offDates)) ? true : ((is_array($offWeekDays) and in_array($dayName, $offWeekDays)) ? true : false);
            if(!self::show_off_dates()) {
                if($is_disable) $skipped_days_count++;
            }
        }
        for($i = 0 + $dayStartFrom; $i <= $daysToShowNumber + $skipped_days_count + $dayStartFrom - 1; $i++) {
            $dayName = strtolower(self::time_date( 'l', $i . ' day'));
            $dayDate_i18n = wcdt_convert_number(self::time_date_i18n( 'Y/m/d', $i . ' day'));
            $dayDate = wcdt_convert_number(self::time_date( 'Y/m/d', $i . ' day'));
            $dayTimestamp = self::date_timestamp( $dayDate );
            $is_disable = (is_array($offDates) and in_array($dayDate_i18n, $offDates)) ? true : ((is_array($offWeekDays) and in_array($dayName, $offWeekDays)) ? true : false);

            if(!self::show_off_dates()) {
                if($is_disable) continue;
            }
            $disableClass = $is_disable ? 'dt-disable-day' : '';
            $dayHours = (isset($deliveryHours[$dayName]) and !empty($deliveryHours[$dayName])) ? $deliveryHours[$dayName] : array();
            ?>
            <tr class="<?php echo $disableClass; ?>">
                <th style="<?php echo (isset($classic_days_bg) and !empty($classic_days_bg)) ? 'background: ' . $classic_days_bg . '!important': ''; ?>">
                    <span style="<?php echo (isset($classic_days_color) and !empty($classic_days_color)) ? 'color: ' . $classic_days_color . '!important': ''; ?>;<?php echo (isset($classic_days_size) and !empty($classic_days_size)) ? 'font-size: ' . $classic_days_size . 'px!important': ''; ?>;<?php echo (isset($classic_days_weight) and !empty($classic_days_weight)) ? 'font-weight: ' . $classic_days_weight . '!important': ''; ?>"><?php echo self::time_date_i18n( 'l', $i . ' day'); ?></span>
                    <span style="<?php echo (isset($classic_days_date_color) and !empty($classic_days_date_color)) ? 'color: ' . $classic_days_date_color . '!important': ''; ?>;<?php echo (isset($classic_days_date_size) and !empty($classic_days_date_size)) ? 'font-size: ' . $classic_days_date_size . 'px!important': ''; ?>;<?php echo (isset($classic_days_date_weight) and !empty($classic_days_date_weight)) ? 'font-weight: ' . $classic_days_date_weight . '!important': ''; ?>"><?php echo self::time_date_i18n( self::date_format(), $i . ' day'); ?></span>
                </th>
                <?php

                foreach($dayHours as $key => $hour) {
                    $hour = self::show_hour($hour);
                    $currentCount = wcdt_get_period_volume($dayTimestamp, $hour['first'].'-'.$hour['second']);

                    $is_disable_range = wcdt_check_hour_to_disable_range($dayDate, $hour, $defaultDeactiveHour, $dayName);


                    if($i === 0) {
                        if($is_disable) {
                            ?>
                            <td class="dt-disable-day">
                                <label for="delivery_date_<?php echo $dayTimestamp; ?>_<?php echo $key; ?>"><?php printf( __( '%s - %s o\'clock', 'wcdt' ), $hour['first'], $hour['second'] ) ?></label>
                            </td>
                            <?php
                        } else {
                            if (wcdt_compare_day_hours($hour, $defaultDeactiveHour, wcdt_convert_number($current_hour)) and !$is_disable_range) {
                                ?>
                                <?php if ($hour['volume'] === 0 or ($currentCount < $hour['volume'])) { ?>
                                    <td>
                                        <input type="radio" name="delivery_date"
                                               id="delivery_date_<?php echo $dayTimestamp; ?>_<?php echo $key; ?>"
                                               value="<?php echo $dayTimestamp . '-' . $hour['first'] . '-' . $hour['second']; ?>">
                                        <label for="delivery_date_<?php echo $dayTimestamp; ?>_<?php echo $key; ?>"><?php printf(__('%s - %s o\'clock', 'wcdt'), $hour['first'], $hour['second']) ?></label>
                                    </td>
                                <?php } else { ?>
                                    <td class="dt-disable-day">
                                        <label for="delivery_date_<?php echo $dayTimestamp; ?>_<?php echo $key; ?>"><?php printf(__('%s - %s o\'clock', 'wcdt'), $hour['first'], $hour['second']) ?></label>
                                    </td>
                                <?php } ?>
                            <?php } else { ?>
                                <td class="dt-disable-day">
                                    <label for="delivery_date_<?php echo $dayTimestamp; ?>_<?php echo $key; ?>"><?php printf(__('%s - %s o\'clock', 'wcdt'), $hour['first'], $hour['second']) ?></label>
                                </td>
                                <?php
                            }
                        }
                    } else {
                        if($is_disable) {
                            ?>
                            <td class="dt-disable-day">
                                <label for="delivery_date_<?php echo $dayTimestamp; ?>_<?php echo $key; ?>"><?php printf( __( '%s - %s o\'clock', 'wcdt' ), $hour['first'], $hour['second'] ) ?></label>
                            </td>
                            <?php
                        } else {
                            if(!$is_disable_range) {
                                ?>
                                <?php if ($hour['volume'] === 0 or ($currentCount < $hour['volume'])) { ?>
                                    <td>
                                        <input type="radio" name="delivery_date"
                                               id="delivery_date_<?php echo $dayTimestamp; ?>_<?php echo $key; ?>"
                                               value="<?php echo $dayTimestamp . '-' . $hour['first'] . '-' . $hour['second']; ?>">
                                        <label for="delivery_date_<?php echo $dayTimestamp; ?>_<?php echo $key; ?>"><?php printf(__('%s - %s o\'clock', 'wcdt'), $hour['first'], $hour['second']) ?></label>
                                    </td>
                                <?php } else { ?>
                                    <td class="dt-disable-day">
                                        <label for="delivery_date_<?php echo $dayTimestamp; ?>_<?php echo $key; ?>"><?php printf(__('%s - %s o\'clock', 'wcdt'), $hour['first'], $hour['second']) ?></label>
                                    </td>
                                <?php }
                            } else {
                                ?>
                                <td class="dt-disable-day">
                                    <label for="delivery_date_<?php echo $dayTimestamp; ?>_<?php echo $key; ?>"><?php printf(__('%s - %s o\'clock', 'wcdt'), $hour['first'], $hour['second']) ?></label>
                                </td>
                                <?php
                            }
                        }
                    }
                }
                ?>
            </tr>
            <?php
        }
        ?>
        </tbody>
    </table>
</div>
<?php do_action('delivery_time_after_list'); ?>